%% Parks McClellan Low Pass Filter Design
% (from http://www.mathworks.com/help/signal/ref/firpmord.html)
close all ;
Fs = 1000 ;
f1 = 0 ;
f2 = 20 ;
f3 = 100;
f4 = 120;
rp = 0.1;           % Passband ripple
rs = 60;          % Stopband ripple
f = [f1 f2 f3 f4];    % Cutoff frequencies
a = [0 1 0];        % Desired amplitudes
dev = [10^(-rs/20)  (10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
[taps_minus_1,fo,ao,w] = firpmord(f,a,dev,Fs);
taps = taps_minus_1+1 ;
b = firpm(taps_minus_1,fo,ao,w);
figure
freqz(b,1,1024,Fs)
title('Lowpass Filter Designed to Specifications')


%% Generate Input

N = Fs ; % 1 sec of data
t = (0:N-1)/Fs ;
f0 = 120 ;
x = 1+1*sin(2*pi*f0*t) ;


%% Filter Signal
Zi = zeros(length(b)-1,1);
[y(1:length(x)/2), Zf] = filter(b,1,x(1,1:end/2),Zi) ;
[y(length(x)/2+1:length(x)), Zf2] = filter(b,1,x(end/2+1:end),Zf) ;
% Remove delay from y
figure ; plot(t,x,'g',t,y,'b') ;
xlabel('Time(s)'); 
legend('Input','Filtered') ;
title('Matlab FIR filter function') ;

