%%  Run program until user presses stop

set(fig.start,'Visible','off')
set(fig.stop,'Visible','on')
set(fig.Time,'Visible','on')
TimeVal = 0;
alltime = 0;

while 1 
    if UserData.stop == false
        if LoadData == 0                                            % Start Calibrate
            if Calibrate == 1
                data = s.startForeground;
                fulldata(TimeVal+1:TimeVal+s.Rate,:) = data;
                clear data;
                TimeVal = TimeVal + s.Rate;                         % Get time value
                DisplayTime = TimeVal/s.Rate;
                DisplayTime = DisplayTime-mod(DisplayTime,1);
                set(fig.Time,'String',num2str(DisplayTime))

                if TimeVal >= StartResting+EachSet*5                % Finish calibration (300 seconds)
                    disp('Please wait ...')
                    name = get(fig.FileName,'String');
                    Reading;                                        % Saving raw data
                        
                    calibrationScriptAll;                           % LDA Method

                    load(['Train2Cat' name(8:end) '.mat'])          % Load calibration data
                    
                    First_TH(1) = tdata.xmark(1);                   % Get first threshold, user can reset threshold
                    First_TH(2) = tdata.xmark(2);
                    First_TH(3) = tdata.xmark(3);
                    First_TH(4) = tdata.xmark(4);
                    First_TH(5) = tdata.xmark(5);                  
                 
                    set(fig.Eth1,'String',thresMAT(1,2))
                    set(fig.Eth2,'String',thresMAT(2,2))
                    set(fig.Eth3,'String',thresMAT(3,2))
                    set(fig.Eth4,'String',thresMAT(4,2))
                    set(fig.Eth5,'String',thresMAT(5,2))
                    set(fig.EPropLDA,'String',ProbLDA)    
                    
                    set(fig.Name1,'Visible','off')
                    set(fig.Name2,'Visible','off')
                    set(fig.RobotName,'Visible','on')
                    
                    set(fig.musclemovement1,'Visible','off')
                    set(fig.musclemovement2,'Visible','off')
                    set(fig.Do,'Visible','off')
                    set(fig.Dont,'Visible','off')
                    set(fig.Time,'Visible','off')

                    set(fig.ModeTest,'Visible','on')
                    
                    Calibrate = 0;
                    i=1;
                end
                Checking                                            % Set calibration data
                i=i+1;
                if Calibrate == 0
                    i = 1;
                end
            
            else                                                    % Start real-time program
                thresholdSet;                                       % Set threshold when user changes threshold
                name = get(fig.FileName,'String');    
                s.DurationInSeconds = .5;       
                dataseg = s.startForeground;                        % Collect 500 ms of data         
                AllData(alltime+1:alltime+s.DurationInSeconds*s.Rate,:) = dataseg;         % Add data to AllData matrix
                
                if size(AllData,1)<8000
                    disp('Calculating Offset')
                end
                if size(AllData,1) == 8000                          % Offset calculation time
                    offset1 = mean(AllData(5000:8000,:));           % Calculate offset after 15 s (read above)
                    disp('Offset Calculated')
                end
                if size(AllData,1) > 8000                           % Collect data ... samples, then send to classification
                    checkMet;                                       % Check Method if user press button --> load new data
                                                                    % if nothing --> no load
                    %startPlot;
                    command_gui                                     % Show the command that send to bionic arm in the command window                   
                    startRobot;
                    
                end    
                
                if (StartTest==1)
                    if ModeTest==1
                        set(fig.PatMovement,'String',Movement_Set{patmove,1})
                        TestingScript_1;                                        % Sentence guide                        
                    elseif ModeTest==2
                        TestingScript_2;                                        % Graphic guide
                        set(fig.PatMovement,'Visible','off')
                    end
                end
                alltime = alltime + 500;
            end
        elseif LoadData == 1                                                                % Starting program and user press button "Load"
            [FileName,PathName]= uigetfile('*.mat','Select Classifier Data');               % Show the pop up for choosing calibration file
            set(fig.FileName,'String',['RawData' FileName(find(FileName == '_'):end-4)]);
            load(FileName)
            
            First_TH(1) = tdata.xmark(1);                                                   % Get the starting threshold
            First_TH(2) = tdata.xmark(2);
            First_TH(3) = tdata.xmark(3);
            First_TH(4) = tdata.xmark(4);
            First_TH(5) = tdata.xmark(5);
            
            set(fig.Eth1,'String',tdata.xmark(1),'Enable','on')
            set(fig.Eth2,'String',tdata.xmark(2),'Enable','on')
            set(fig.Eth3,'String',tdata.xmark(3),'Enable','on')
            set(fig.Eth4,'String',tdata.xmark(4),'Enable','on')
            set(fig.Eth5,'String',tdata.xmark(5),'Enable','on')
            
            set(fig.Movement1,'Visible','on')
            set(fig.Movement2,'Visible','on')
            set(fig.Movement3,'Visible','on')
            set(fig.Movement4,'Visible','on')
            set(fig.Movement5,'Visible','on')
            set(fig.ModeLabel,'Visible','on')
            
            set(fig.EMovement1,'Visible','on')
            set(fig.EMovement2,'Visible','on')
            set(fig.EMovement3,'Visible','on')
            set(fig.EMovement4,'Visible','on')
            set(fig.EMovement5,'Visible','on')
            set(fig.Mode,'Visible','on')
            
            set(fig.Name1,'Visible','off')
            set(fig.Name2,'Visible','off')
            set(fig.RobotName,'Visible','on')

            set(fig.ModeTest,'Visible','on')
            
            LoadData = 0;
            Calibrate = 0;
        end
    elseif UserData.stop==true    % End program
        if exist('AllData')
            save(['..\Full Program\All Data\AllData' name(find(name=='_'):end) '.mat'],'AllData')
        end
        close all
        break;
    end
    drawnow;
end