%   Full Calibration, Classification, Robot Control GUI 

close all
clear all
clc
%% START NI DAQ SESSION

% ch = 5; % set number of channels
% s = daq.createSession('ni');
% s.addAnalogInputChannel('Dev1',0:ch-1,'Voltage');
% s.DurationInSeconds = 1; % set acquisition chunk
% s.Rate = 1000; % set sampling rate

%% START FANUC CONNECTION

% number_of_retries = 2; % set to -1 for infinite
% port=2057; % This code use for communication "port" and "port+1"
% host='localhost';   
% samplingrate=1000; %in ms

%%  MAIN FIGURE

%   FIGURE
fig.f = figure('Position',[80 100 1250 600],'Name','Myoelectric Control Scheme','Resize','off','Menubar','None');
               
%   FRAME 1,2,3
fig.frame1 = uicontrol('Style','frame','Position',[10 10 300 580]);
fig.frame2 = uicontrol('Style','frame','Position',[340 10 300 580]);

%   STOP BUTTON
fig.stop = uicontrol('Style','PushButton','String','End','position',[1050 20 150 50],'FontSize',15,'Callback','UserData.stop = true;');

%   NAME & FRAME
fig.NameFrame1 = uicontrol('Style','Frame','Position',[20 490 280 90]);
fig.NameFrame2 = uicontrol('Style','Frame','Position',[355 490 270 90]);
fig.Name1 = uicontrol('Style','Radio','String','Calibrate','FontSize',30,'Position',[30 535 250 40],'value',1,'callback','calib = 1; record = 0; fig.Name2.Value = 0;');
fig.Name2 = uicontrol('Style','Radio','String','Record','FontSize',30,'Position',[30 495 250 40],'callback','record = 1; calib = 0; fig.Name1.Value = 0;');
fig.Name3 = uicontrol('Style','Text','String','Parameters','FontSize',35,'Position',[365 500 250 70]);  
fig.RobotName = uicontrol('Style','Text','String','Robot Control','FontSize',30,'Position',[35 495 250 70],'Visible','off');

%%  CALIBRATION WINDOW

%   START BUTTON
fig.start = uicontrol('Style','PushButton','String','Start','position',[ 85 115 150 50],'FontSize',15,'Callback','startLoop');
fig.stopRecord = uicontrol('Style','PushButton','String','Stop','position',[ 85 115 150 50],'FontSize',15,'Callback','UserData.stopRecord = true;','visible','off');

%   LOAD DATA
fig.Load = uicontrol('Style','PushButton','String','Load','position',[ 85 40 150 50],'FontSize',15,'Callback', 'loadData');
    
%   RESET THRESHOLD
fig.ResetThreshold = uicontrol('Style','PushButton','String','Reset Threshold','position',[ 85 30 150 50],'FontSize',15,'Visible','off','Callback', 'ResetThreshold');
    
%   MUSCLE MOVEMENT TYPE
fig.musclemovement1 = uicontrol('Style','Text','FontSize',30,'position',[75 400 180 70]);
fig.musclemovement2 = uicontrol('Style','Text','FontSize',30,'Visible','off','position',[65 340 200 70]);
    
%   CONTRACT MUSCLE
fig.Do = uicontrol('Style','Text','String','Move','BackgroundColor',[0 1 0],'FontSize',30,'position',[85 250 150 50],'ForegroundColor',[0 0 0],'Visible','off');
    
%   RELAX MUSCLE
fig.Dont = uicontrol('Style','Text','String','Relax','BackgroundColor',[1 0 0],'FontSize',30,'position',[85 250 150 50],'ForegroundColor',[0 0 0],'Visible','off');
    
%   DISPLAY TIME (SECONDS)
fig.Time = uicontrol('Style','Text','FontSize',35,'position',[105 180 110 55]);

%%  SET LDA THRESHOLDS WINDOW

%   THRESHOLD 1
fig.th1 = uicontrol('Style','Text','String','Threshold 1','FontSize',20,'Position',[365 420 150 40]);
fig.Eth1 = uicontrol('Style','Edit','FontSize',20,'String',0,'Enable','off','Position',[530 420 100 40]);
    
%   THRESHOLD 2
fig.th2 = uicontrol('Style','Text','String','Threshold 2','FontSize',20,'Position',[365 350 150 40]);
fig.Eth2 = uicontrol('Style','Edit','FontSize',20,'String',0,'Enable','off','Position',[530 350 100 40]);
    
%   THRESHOLD 3
fig.th3 = uicontrol('Style','Text','String','Threshold 3','FontSize',20,'Position',[365 280 150 40]);    
fig.Eth3 = uicontrol('Style','Edit','FontSize',20,'String',0,'Enable','off','Position',[530 280 100 40]);
    
%   THRESHOLD 4
fig.th4 = uicontrol('Style','Text','String','Threshold 4','FontSize',20,'Position',[365 210 150 40]);   
fig.Eth4 = uicontrol('Style','Edit','FontSize',20,'String',0,'Enable','off','Position',[530 210 100 40]);
    
%   THRESHOLD 5
fig.th5 = uicontrol('Style','Text','String','Threshold 5','FontSize',20,'Position',[365 140 150 40]);
fig.Eth5 = uicontrol('Style','Edit','FontSize',20,'String',0,'Enable','off','Position',[530 140 100 40]);
    
%   Percent LDA Prop.
fig.PropLDA = uicontrol('Style','Text','String','Sensitivity','FontSize',20,'Position',[365 50 150 40]);    
fig.EPropLDA = uicontrol('Style','Edit','FontSize',20,'String',0,'Enable','off','Position',[530 50 100 40]);   

%%  COMMAND TO BEBIONIC HAND

%   MOVEMENT 1
fig.Movement1 = uicontrol('Style','Text','String','Biceps Contraction','FontSize',15,'Visible','off','Position',[15 420 130 50]);    
fig.EMovement1 = uicontrol('Style','Popup','Visible','off','String',['+X|-X|Mode Switch|+Mode|-Mode'],'Value',1,'FontSize',15,'Position',[150 420 150 40]);

%   MOVEMENT 2
fig.Movement2 = uicontrol('Style','Text','Visible','off','String','Triceps Contraction','FontSize',15,'Position',[15 350 130 50]);
fig.EMovement2 = uicontrol('Style','Popup','Visible','off','String',['+X|-X|Mode Switch|+Mode|-Mode'],'Value',2,'FontSize',15,'Position',[150 350 150 40]);

%   MOVEMENT 3
fig.Movement3 = uicontrol('Style','Text','String','Shoulder Elevation','FontSize',15,'Visible','off','Position',[15 280 130 50]);    
fig.EMovement3 = uicontrol('Style','Popup','Visible','off','String',['+X|-X|Mode Switch|+Mode|-Mode'],'Value',3,'FontSize',15,'Position',[150 280 150 40]);
        
%   MOVEMENT 4
fig.Movement4 = uicontrol('Style','Text','String','Shoulder Protraction','FontSize',15,'Visible','off','Position',[15 210 130 50]);    
fig.EMovement4 = uicontrol('Style','Popup','Visible','off','String',['+X|-X|Mode Switch|+Mode|-Mode'],'Value',4,'FontSize',15,'Position',[150 210 150 40]);
       
%   MOVEMENT 5
fig.Movement5 = uicontrol('Style','Text','String','Shoulder Retraction','FontSize',15,'Visible','off','Position',[15 140 130 50]);
fig.EMovement5 = uicontrol('Style','Popup','Visible','off','String',['+X|-X|Mode Switch|+Mode|-Mode'],'Value',5,'FontSize',15,'Position',[150 140 150 40]);  

%   MODE
fig.ModeLabel = uicontrol('Style','Text','String','Mode','FontSize',20,'Visible','off','Position',[15 50 130 40]);
fig.Mode = uicontrol('Style','Text','String','1','Visible','off','FontSize',20,'Position',[150 50 150 40]);  

%%  CLASSIFICATION METHOD

fig.BMethod = uicontrol('Style','Popup','FontSize',20,'Position',[890 25 130 40],'String',['commandLDA_2Cat|commandLDA_Bounds|commandLDA'],'Value',1);    
fig.FileName = uicontrol('Style','Edit','Position',[700 25 170 40],'String','RawData_','FontSize',15);   

%%  TRAINING GUIDE GRAPHIC

fig.plot = axes('Units','pixels','Position',[685 100 520 390],'Visible','off');
fig.label = uicontrol('Style','text','Fontsize',7,'Position',[1055 428 150 60],...
    'String',{'Biceps Contraction (Dark Blue)';'Shoulder Elevation (Green)';'Shoulder Protraction (Red)';'Shoulder Retraction (Light Blue)';'Triceps Contraction (Pink)'},...
    'BackgroundColor',[0 0 0],'ForegroundColor',[1 1 1],'Visible','off');
angle = 18:72:360;
angle = degtorad(angle);
x = 25*cos(angle);
y = 25*sin(angle);

hold all
set(gca,'Color',[0 0 0],'XTick', [],'YTick', [],'NextPlot','replacechildren');
fig.c1 = plot(x(1),y(1),'o','MarkerEdgeColor','b','MarkerSize',30,'HandleVisibility','off','Visible','off');
fig.c2 = plot(x(2),y(2),'o','MarkerEdgeColor','g','MarkerSize',30,'HandleVisibility','off','Visible','off');
fig.c3 = plot(x(3),y(3),'o','MarkerEdgeColor','r','MarkerSize',30,'HandleVisibility','off','Visible','off');
fig.c4 = plot(x(4),y(4),'o','MarkerEdgeColor','c','MarkerSize',30,'HandleVisibility','off','Visible','off');
fig.c5 = plot(x(5),y(5),'o','MarkerEdgeColor','m','MarkerSize',30,'HandleVisibility','off','Visible','off');
fig.c6 = plot(0,0,'o','MarkerEdgeColor','w','MarkerFaceColor','w','MarkerSize',20,'HandleVisibility','on','Visible','off');
xlim([-35 35]);
ylim([-35 35]);

%%  TRAINING GUIDE SENTENCE

fig.sentenceguide = uicontrol('Style','Text','Position',[700 510 380 60],'FontSize',28,'BackgroundColor',[0 1 0],'Visible','off');
fig.PatMovement = uicontrol('Style','Text','Position',[730 300 380 60],'FontSize',30,'BackgroundColor',[1 0 1],'Visible','off');   
fig.ModeTest = uicontrol('Style','PushButton','Position',[1110 510 100 60],'String','Start','FontSize',15,'Visible','off','Callback','GoToScript'); 

%% GRAPHIC RADIO BUTTON

fig.graphic = uicontrol('Style','Radio','Position',[700 510 100 60],'BackgroundColor',[.8 .8 .8],'String','Graphic','FontSize',15,'Visible','on','Callback','plotting');

%%  VARIABLE INITIALIZATION

UserData = get(gcf,'UserData');
UserData.stop = 0; UserData.stopRecord = 0;
calib = 1; record = 0;
state = 1;
Calibrate = 1;
LoadData = 2;
ClassRecord = 0;
Method = 1;
CheckMethod = 1;
PressButton = false;
ProbLDA = .99;
classed = 6;
j = 1;
count = 0;
nnn = 1;
patmove = 1;
startplot_i = 1;
v=0; x=0; w=0; y=0; z=0;
current = [400 0 25 -90 0 -90 1];
mode = 1; grip = 1;

StartTest = 3;
ModeTest = 1;
Trial_1 = [];
Trial_2 = [];
num_1 = 0;
num_2 = 0;
save1 = 1;
save2 = 1;

%% TESTING TIMING
r_1 = 1;
move_num = 2;
round_move = 3;

Movement_Set = {'Resting';'Biceps Contraction';'Shoulder Elevation';'Shoulder Protraction';'Shoulder Retraction';'Triceps Contraction'};
CTPeriod = 2000;    % Contraction Period
RLPeriod = 3000;    % Relaxing Period
DoTime = 10;        % Do it 10 times

for i=1:DoTime*10
    if i==1
        MarkTime_1(i,1) =  0;
        MarkTime_1(i,2) =  0;
        MovePatern{i,1} = Movement_Set{1,1};
    elseif i==2
        MarkTime_1(i,1) =  RLPeriod;
        MarkTime_1(i,2) =  1;
        MovePatern{i,1} = Movement_Set{move_num,1};        
        getT1 = RLPeriod;
    else
        if mod(i,2)==1
            MarkTime_1(i,1) =  getT1+CTPeriod;
            MovePatern{i,1} = Movement_Set{1,1};
            MarkTime_1(i,2) =  0;
            round_move = round_move+1;
            if round_move>DoTime*2
                round_move = 1;
                move_num=move_num+1;
            end
            getT1 = MarkTime_1(i,1);
        elseif mod(i,2)==0
            MarkTime_1(i,1) =  getT1+RLPeriod;
            MarkTime_1(i,2) =  1;
            MovePatern{i,1} = Movement_Set{move_num,1};
            round_move = round_move+1;
            if round_move>DoTime*2
                round_move = 1;
                move_num=move_num+1;
            end
            getT1 = MarkTime_1(i,1);  
        end
    end
end

%% CALIBRATION TIMING

StartResting = 10000;   % Start calibration in resting stage (ms)
RestingSet = 5000;      % Resting after finish each set (ms)
ContractPeriod = 3000;  % Contrction muscle (ms)
RelaxPeriod = 2000;     % Relax muscle (ms)
TimePerSet = 10;        % number of time to contract and relax

ConRest = (ContractPeriod+RelaxPeriod)*TimePerSet;
EachSet = RestingSet+ConRest;

GetTime = 0;
PatDo = 1;

i=1;   