clear all
close all
clc

ch = 5; % set number of channels
s = daq.createSession('ni');
s.addAnalogInputChannel('Dev1',0:ch-1,'Voltage');
s.DurationInSeconds = 1; % set acquisition chunk
s.Rate = 1000; % set sampling rate

number_of_retries = 2; % set to -1 for infinite
port=2057; % This code use for communication "port" and "port+1"
host='localhost';   
samplingrate=1000; %in ms
fulldata = [];
fullfilt = [];
j = 1;
raw = figure();
filtered = figure();

% Zi = zeros(length(b)-1,1);

while 1
    tic;
    data = s.startForeground;
    fulldata = [fulldata; data];
    
    figure(raw)
    subplot(5,1,1) 
    plot(fulldata(:,1))
    subplot(5,1,2)
    plot(fulldata(:,2))
    subplot(5,1,3)
    plot(fulldata(:,3))
    subplot(5,1,4)
    plot(fulldata(:,4))
    subplot(5,1,5)
    plot(fulldata(:,5))
    
    values_to_send = [350+j*10 50 0 -90 0 -90 1];
    data_to_send = '' ;
    for i=1:length(values_to_send)
        data_to_send = [data_to_send,num2str(values_to_send(i),'%15.6f')];
        if ( i ~= length(values_to_send) )
            data_to_send = [data_to_send,','] ;
        end
    end
    data_to_send;
    data_received=exchangeData(port,host,number_of_retries,samplingrate,Double2CSV(values_to_send));
    j = j + 1;
    if j > 20
        j = 1;
    end
    
%     [filterdata, Zi] = filter(b,1,data(:,2),Zi);
%     fullfilt = [fullfilt; filterdata];
    

    
%     figure(filtered)
%     plot(fulldata(:,2))
%     hold on
%     plot(fullfilt)
%     hold off
    
    drawnow;
    time(i) = toc;
end