function [command_gui,classed,v,w,x,y,z] = practice_Euclid(tdata,v,w,x,y,z,classed,data)

traindata = tdata.traindata;
traindatalabel = tdata.traindatalabel;
thresMAT = tdata.thresMAT;

set_t = 500; %feature window size
seg = 250;
ch = 5;
command_gui = zeros(1,5); %command matrix
rat = 3/3;

for i = 1:5
    evalc(['thres' num2str(i) '=thresMAT('  num2str(i)  ',2);']);
    evalc(['tCH' num2str(i) '=thresMAT('  num2str(i)  ',1);']);
end

%% read data

for i = 1:ch
    emg_win(:,i) = data(:,i);
end

%% moving average
ave_win = emg_win(1:seg,1:ch);
ave_win = ave_win.^2;
mov_ave = mean(ave_win,1);

if classed == 6
    v = mov_ave(tCH1)>rat*thres1;
    w = mov_ave(tCH2)>rat*thres2;
    x = mov_ave(tCH3)>rat*thres3;
    y = mov_ave(tCH4)>rat*thres4;
    z = mov_ave(tCH5)>rat*thres5;
    if v || w || x || y || z
        %% mean absolute value
        emg_abs = abs(emg_win);
        MAV = zeros(1,ch);
        MAV = mean(emg_abs,1);
        
        clear gi abs_win
        
        %% zero crossings
        zc = zeros(1,ch);
        for ai = 1:ch
            for ci = 1:set_t-1
                if emg_win(ci,ai)<0 && emg_win(ci+1,ai)>0 && abs(emg_win(ci,ai)-emg_win(ci+1,ai))>=0.01
                    zc(ai) = zc(ai) + 1;
                elseif emg_win(ci,ai)>0 && emg_win(ci+1,ai)<0 && abs(emg_win(ci,ai)-emg_win(ci+1,ai))>=0.01
                    zc(ai) = zc(ai) + 1;
                end
            end
        end
        
        clear ai ci
        
        %% slope sign change
        m_sign = zeros(1,ch);
        for ai = 1:ch
            for ci = 1:set_t-2
                if emg_win(ci+1,ai)>emg_win(ci+2,ai) && emg_win(ci+1,ai)>emg_win(ci+2,ai) && abs(emg_win(ci+1,ai)-emg_win(ci,ai))>=0.01
                    m_sign(ai) = m_sign(ai) + 1;
                elseif emg_win(ci+1,ai)<emg_win(ci+2,ai) && emg_win(ci+1,ai)<emg_win(ci+2,ai) && abs(emg_win(ci+1,ai)-emg_win(ci,ai))>=0.01
                    m_sign(ai) = m_sign(ai) + 1;
                end
            end
        end
        
        clear ai ci
        
        %% waveform length
        l = zeros(1,ch);
        for di = 1:ch
            for k = 1:set_t-1
                l(di) = l(di) + abs(emg_win(k+1,di) - emg_win(k,di));
            end
        end
        
        clear di j
        
        
        datamat = [MAV zc m_sign l];
        distmat = zeros(size(traindata,1),1);
            
        %% std calculation
        difftemp = zeros(size(traindata,1),size(traindata,2));
        
        for bi = 1:size(traindata,1)
            distmat(bi,1) = sqrt(sum(abs(datamat.^2 - traindata(bi,:).^2),2));
            difftemp(bi,:) = abs(datamat - traindata(bi,:));
        end
        
        diff = difftemp < stddata;
        mindiff = zeros(size(traindata,1),1);
        
        for ai = 1:size(traindata,1)
            mindiff(ai) = sum(diff(ai,:) == 1);
        end
            
            %% > std method
%             f = 2;
%             class = find(mindiff==max(mindiff));
%             
%             if size(find(mindiff==max(mindiff)),1) == 1
%                 if max(mindiff)>10
%                     classed = class;
%                 else
%                     classed = 6;
%                 end
%             else
%                 classed = 6;
%             end
            
            %% > std && distance method
%             f = 3;
%             classA = find(mindiff == max(mindiff));
%             class = find(distmat == min(distmat));
%             if size(classA,1) == 1
%                 if max(mindiff)>6 && classA==class
%                     classed = class;
%                 else
%                     classed = 6;
%                 end
%             else
%                 classed = 6;
%             end

            %% max std method
%             f = 4;
%             class = find(mindiff == max(mindiff));
%             if size(class,1) == 1
%                 classed = class;
%             else
%                 classed = 6;
%             end

            %% max std && distance method
            f = 5;
            class = find(distmat == min(distmat));
            if find(mindiff==max(mindiff)) == class
                classed = class;
            else
                classed = 6;
            end
            
            %% distance method
%             f = 6;
%             for bi = 1:size(traindata,1)
%                 distmat(bi,1) = sqrt(sum(abs(datamat.^2 - traindata(bi,:).^2),2));
%             end
%             classed = find(distmat == min(distmat));
%             
            %% min distance requirement
%             mindist = min(distmat);
%             if mindist < 30
%                 classed = find(distmat == min(distmat));
%             end

    end
elseif v && mov_ave(tCH1)<rat*thres1
    classed = 6;
elseif w && mov_ave(tCH2)<rat*thres2
    classed = 6;
elseif x && mov_ave(tCH3)<rat*thres3
    classed = 6;
elseif y && mov_ave(tCH4)<rat*thres4
    classed = 6;
elseif z && mov_ave(tCH5)<rat*thres5
    classed = 6;
end

if classed ~= 6
    command_gui(1,classed) = 1;
else
    command_gui = zeros(1,5);
end

end