%%  Run program until user presses stop

set(fig.start,'Visible','off')
set(fig.stop,'Visible','on')
set(fig.Time,'Visible','on')
RecTime = 0;
IterT = 1;

while 1
    if UserData.stop == false
        if LoadRecord == 0
            if UserData.stopRecord == false
                s.DurationInSeconds = .5;
                data = s.startForeground;
                RecData(RecTime+1:RecTime+s.Rate*s.DurationInSeconds,:) = data;
                if RecTime == 0
                    RealPlot = figure();
                end
                clear data
                RecTime = RecTime + s.Rate*s.DurationInSeconds;
                RecDispTime = RecTime/s.Rate;
                RecDispTime = RecDispTime-mod(RecDispTime,1);
                set(fig.Time,'String',num2str(RecDispTime))
                
                if RecTime < 5000
                    figure(RealPlot)
                    subplot(5,1,1)
                    plot(RecData(:,1))
                    subplot(5,1,2)
                    plot(RecData(:,2))
                    subplot(5,1,3)
                    plot(RecData(:,3))
                    subplot(5,1,4)
                    plot(RecData(:,4))
                    subplot(5,1,5)
                    plot(RecData(:,5))
                else
                    figure(RealPlot)
                    subplot(5,1,1)
                    plot(RecData(end-4999:end,1))
                    subplot(5,1,2)
                    plot(RecData(end-4999:end,2))
                    subplot(5,1,3)
                    plot(RecData(end-4999:end,3))
                    subplot(5,1,4)
                    plot(RecData(end-4999:end,4))
                    subplot(5,1,5)
                    plot(RecData(end-4999:end,5))
                end
                
            elseif UserData.stopRecord == true
                if exist('RealPlot')
                    figure(RealPlot)
                    close gcf
                    clear RealPlot
                end
                
                if exist('RecData')
                    RecData = detrend(RecData);
                    name = get(fig.FileName,'String');
                    save(['..\Full Program\Rec Data\RecData' name(find(name=='_'):end) '.mat'],'RecData')
                end
                set(fig.stopRecord,'Visible','Off')
                set(fig.Load,'Visible','On')
                set(fig.Time,'Visible','Off')
            end
        elseif LoadRecord == 1
            set(fig.Time,'Visible','Off')
            if ClassRecord == 0
                [RecFile,RecPath]= uigetfile('*.mat','Select Recorded Data');                                                % Show the pop up for choosing EMG file
                set(fig.FileName,'String',['RecData' RecFile(find(RecFile == '_'):end-4)]);
                load(RecFile)
                [FileName,PathName]= uigetfile('*.mat','Select Classifier Data');                                            % Show the pop up for choosing calibration file
                load(FileName)
                
            First_TH(1) = tdata.xmark(1);                                                   % Get the starting threshold
            First_TH(2) = tdata.xmark(2);
            First_TH(3) = tdata.xmark(3);
            First_TH(4) = tdata.xmark(4);
            First_TH(5) = tdata.xmark(5);
            
            set(fig.Eth1,'String',tdata.xmark(1),'Enable','on')
            set(fig.Eth2,'String',tdata.xmark(2),'Enable','on')
            set(fig.Eth3,'String',tdata.xmark(3),'Enable','on')
            set(fig.Eth4,'String',tdata.xmark(4),'Enable','on')
            set(fig.Eth5,'String',tdata.xmark(5),'Enable','on')
            
            set(fig.Movement1,'Visible','on')
            set(fig.Movement2,'Visible','on')
            set(fig.Movement3,'Visible','on')
            set(fig.Movement4,'Visible','on')
            set(fig.Movement5,'Visible','on')
            set(fig.ModeLabel,'Visible','on')
            
            set(fig.EMovement1,'Visible','on')
            set(fig.EMovement2,'Visible','on')
            set(fig.EMovement3,'Visible','on')
            set(fig.EMovement4,'Visible','on')
            set(fig.EMovement5,'Visible','on')
            set(fig.Mode,'Visible','on')
            
            set(fig.Name1,'Visible','off')
            set(fig.Name2,'Visible','off')
            set(fig.RobotName,'Visible','on')
            
                ClassRecord = 1;
            elseif ClassRecord == 1
                FullT = size(RecData,1)-500;
                if IterT < FullT
                    dataseg = RecData(IterT:IterT+499,:);
                    offset1 = [0 0 0 0 0];
                    checkMet;
                    command_gui
                    startRobot;
                    set(fig.Mode,'String',mode)
                end
                IterT = IterT + 500;
            end
        end
    elseif UserData.stop==true    % End program
        close all
        break;
    end
    drawnow;
end
